我是靠谱客的博主 心灵美蓝天,最近开发中收集的这篇文章主要介绍LeetCode——1.两数之和(C++),觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

题目

Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

个人理解

给定一个整型数组nums以及一个整型目标数target,寻找数组中两个数和为target,并返回这两个数的下标。题目假设了只需要寻找出一个解便可,但是不能重复使用同一个元素。

例如

Given nums = [2, 4, 1, 3], target = 4,
return [1, 1]. 错误

我的第一反应就是穷举法,通过两次for循环遍历得出结果。

vector<int> twoSum(vector<int> &nums, int target)
{
	vector<int> res;
	for (int i = 0; i < nums.size(); i++)
	{
		for (int j = i + 1; j < nums.size(); j++)
		{
			if (nums[j] == target - nums[i])
			{
				res.push_back(i);
				res.push_back(j);
				break;
			}
		}
	}
	return res;
}

以下是LeetCode的解法,代码源自他人。

解法一: 两遍哈希表

vector<int> twoSum(vector<int> &nums, int target)
{
	vector<int> res;
	unordered_map<int, int> m;
	for (int i = 0; i < nums.size(); i++)
	{
		m[nums[i]] = i;		// 插入哈希表中
	}
	for (int i = 0; i < nums.size(); i++)
	{
		int t = target - nums[i];
		if (m.count(t) && m[t] != i) {
			res.push_back(i);
			res.push_back(m[t]);
			break;
		}
	}
	return res;
}

其中的m.count(t) 表示为键值为t的元素的个数,但根据其实现原理,相同键值元素只能有一个,因此返回值要么为0要么为1。
因此这个算法没有解决给定的nums数组含有重复元素的问题,但不是问题的重点。

解法二: 一遍哈希表

vector<int> twoSum(vector<int> &nums, int target)
{
	vector<int> res;
	unordered_map<int, int> m;
	for (int i = 0; i < nums.size(); i++)
	{
		int t = target - nums[i];
		if (m.count(t) && m[t] != i) {
			res.push_back(m[t]);
			res.push_back(i);
			break;
		}
		m[nums[i]] = i;		// 插入哈希表中

	}
	return res;
}

LeetCode中哈希解法是假设不存在冲突的,这样查找的时间复杂度是接近常数级的,整体算法的时间复杂度就来源于第一次插入hash表中,为O(n)。

解法三:红黑树(留坑代填)

红黑树的查找效率为O(logn),在某些情况下,效率并不比hash慢。

笔者水平有限,欢迎提问。

最后

以上就是心灵美蓝天为你收集整理的LeetCode——1.两数之和(C++)的全部内容,希望文章能够帮你解决LeetCode——1.两数之和(C++)所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(41)

评论列表共有 0 条评论

立即
投稿
返回
顶部